BRR_ENABLED = true
BRR_LOGGING = true
BRR_BIJOUS = true
BRR_COINS = true
logged_off_time = 0
coinList = {}
bijouList = {}
lootList = {}
lastGroupMembers = 0
local coinsDistributed = 0
local bijousDistributed = 0
local frame = CreateFrame("FRAME", "BijouRR")
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGOUT")
frame:RegisterEvent("LOOT_OPENED")

local function count(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

local function printIfEnabled(words)
	if BRR_LOGGING then
		print(words)
	end
end

local function GetValidMasterLootMembers(li)
	local count = 0
	for ci = 1, GetNumGroupMembers() do
		local memName = GetMasterLootCandidate(li, ci)
		if memName then
			count = count + 1
		end
	end
	lastGroupMembers = count
	return count
end

local function AddUpdateLootList(itemName, memName)
	if not lootList[memName] then
		lootList[memName] = itemName
		return
	end
	
	lootList[memName] = lootList[memName] .. ", " .. itemName
end

local function TryToDistributeCoin(li, itemName)
	local distributed = false
	local groupMembers = GetValidMasterLootMembers(li)
	for ci = 1, 40 do
		local memName = GetMasterLootCandidate(li, ci)
		if not memName then
			return distributed
		end
		if not coinList[memName] then
			GiveMasterLoot(li, ci)
			coinList[memName] = time()
			AddUpdateLootList(itemName, memName)
			printIfEnabled("BijouRR: Giving " .. itemName .. " to " .. memName)
			coinsDistributed = coinsDistributed + 1
			printIfEnabled("BijouRR: Coins Completed " .. coinsDistributed .. "/" .. groupMembers)
			distributed = true
			break
		end
	end	
	return distributed
end

local function TryToDistributeBijou(li, itemName)
	local distributed = false
	local groupMembers = GetValidMasterLootMembers(li)
	for ci = 1, 40 do
		local memName = GetMasterLootCandidate(li, ci)
		if not memName then
			return distributed
		end
		if not bijouList[memName] then
			GiveMasterLoot(li, ci)
			bijouList[memName] = time()
			AddUpdateLootList(itemName, memName)
			printIfEnabled("BijouRR: Giving " .. itemName .. " to " .. memName)
			bijousDistributed = bijousDistributed + 1
			printIfEnabled("BijouRR: Bijous Completed " .. bijousDistributed .. "/" .. groupMembers)
			distributed = true
			break
		end
	end	
	return distributed
end

local function eventHandler(self, event, arg1, ...)
	if event == "ADDON_LOADED" then
		if arg1 == "BijouRR" then
			print("|cffFFFF00" .. arg1 .. "|r" .. " - Loaded and Enabled")
			local diff = time() - logged_off_time
			if diff > 3600 then
				coinList = {}
				bijouList = {}
				lootList = {}
			end
		end
		return
	elseif event == "PLAYER_LOGOUT" then
		logged_off_time = time()
		return
	end
	
	--LOOT_OPENED BELOW HERE
	if BRR_ENABLED == false then
		return
	end

	local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
    if lootmethod == "master" and masterlooterPartyID == 0 then
		for li = 1, GetNumLootItems() do
			local itemLink = GetLootSlotLink(li)
			if itemLink then
				local itemName = GetItemInfo(itemLink)
				if itemName then
					local itemIsCoin = string.find(itemName, "Coin$")
					local itemIsBijou = string.find(itemName, "Bijou$")
					if BRR_COINS and itemIsCoin then
						local distributed = TryToDistributeCoin(li, itemName)
						if not distributed then
							printIfEnabled("BijouRR: Finished Coin Cycle, Starting Over!")
							coinsDistributed = 0
							wipe(coinList)
							TryToDistributeCoin(li, itemName)
						end
						break
					elseif BRR_BIJOUS and itemIsBijou then
						local distributed = TryToDistributeBijou(li, itemName)
						if not distributed then
							printIfEnabled("BijouRR: Finished Bijou Cycle, Starting Over!")
							bijousDistributed = 0
							wipe(bijouList)
							TryToDistributeBijou(li, itemName)
						end
						break
					end
				end
			end
		end
	end
end

frame:SetScript("OnEvent", eventHandler);

SLASH_BIJOURR1 = "/brr"

SlashCmdList.BIJOURR = function(input)
	input = string.lower(input)
	if input == "log" then
		BRR_LOGGING = not BRR_LOGGING
		local word = "Disabled"
		if BRR_LOGGING then
			word = "Enabled"
		end
		print("BijouRR: Logging " .. word)
		return
	elseif input == "coin" then
		BRR_COINS = not BRR_COINS
		local word = "Disabled"
		if BRR_COINS then
			word = "Enabled"
		end
		print("BijouRR: Coins " .. word)
		return	
	elseif input == "bijou" then
		BRR_BIJOUS = not BRR_BIJOUS
		local word = "Disabled"
		if BRR_BIJOUS then
			word = "Enabled"
		end
		print("BijouRR: Bijous " .. word)
		return
	elseif input == "reset" then
		coinList = {}
		bijouList = {}
		lootList = {}
		coinsDistributed = 0
		bijousDistributed = 0
		print("BijouRR: Round Robin Rotation has been reset")
		return
	elseif input == "history" then
		local lootCount = 0
		for i,v in pairs(lootList) do
			print(i .. ": " .. v)
			lootCount = lootCount + 1
		end
		if lootCount == 0 then
			print("No items have been distributed yet")
		end
		return
	elseif input == "status" then
		print("BijouRR: Bijous Completed " .. bijousDistributed .. "/" .. lastGroupMembers)
		print("BijouRR: Coins Completed " .. coinsDistributed .. "/" .. lastGroupMembers)
		for i, v in pairs(lootList) do
			local _, bijous = string.gsub(string.lower(v), "bijou", "bijou")
			local _, coins = string.gsub(string.lower(v), "coin", "coin")
			print(i .. ": " .. bijous .. " Bijous, " .. coins .. " Coins")
		end
		return
	elseif input == "help" then
		print("Bijou Round Robin Commands")
		print("---------------------------------------------------")
		print("|cffFFFF00/brr|r" .. " - Entirely Enable/Disable the Addon")
		print("|cffFFFF00/brr log|r" .. " - Enable/Disable the Reporting of the Addon")
		print("|cffFFFF00/brr coin|r" .. " - Enable/Disable the Distribution of Coins")
		print("|cffFFFF00/brr bijou|r" .. " - Enable/Disable the Distribution of Bijous")
		print("|cffFFFF00/brr reset|r" .. " - Force Reset the round robin rotation and loot history")
		print("|cffFFFF00/brr history|r" .. " - Display Record of all loot history")		
		print("|cffFFFF00/brr status|r" .. " - Display Record of current cycle status as well as condensed loot history")		
		return
	elseif input == "" then
	else
	
		print("BijouRR: Invalid Command, Input '/brr help' to get a list of available commands")
		return
	end

	if BRR_ENABLED then
		BRR_ENABLED = false
		print("BijouRR: Disabled")
	else
		BRR_ENABLED = true
		print("BijouRR: Enabled")
	end
end